local playerName, playerRealm = UnitName("player"), GetRealmName()
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

local dataobj = ldb:GetDataObjectByName("Ilvl") or ldb:NewDataObject("Ilvl", {
	type = "data source", icon = [[Interface\Icons\INV_Misc_Bag_12]], text = "0/0",
	OnTooltipShow = function(tip)
		for playerRealm, perso in pairs(Broker_ilvlDB) do
			tip:AddLine("Characters on " .. playerRealm)

			for k,v in pairs(perso) do
				tip:AddDoubleLine(k, v, 1,1,1, 1,1,1)
			end
	
		end
		
	end,
})

function calculateText() 
	local overall, equipped = GetAverageItemLevel()
	overall=round(overall,1)
	equipped=round(equipped,1)
	
	if overall-equipped > 10 then 
		equipped="|cffff0000" .. equipped .. "|r" 
	else
		if overall-equipped > 2 then 
			equipped="|cffffff55" .. equipped .. "|r"
		else
			equipped="|cff00ff00" .. equipped .. "|r"
		end
	end
	return equipped .. " / " .. overall
end

function UpdateText()
	dataobj.text = calculateText()
	Broker_ilvlDB[playerRealm][playerName] =  dataobj.text
end

local EVENTS = {};
EVENTS.ADDON_LOADED = "ADDON_LOADED"
EVENTS.QUEST_DETAIL = "PLAYER_EQUIPMENT_CHANGED";
EVENTS.PLAYER_LOGIN = "PLAYER_LOGIN";
EVENTS.UNIT_INVENTORY_CHANGED = "UNIT_INVENTORY_CHANGED";

function BI_OnEvent(self, event, ...)
	BI_LocalMessage("Event : " .. event)
	if event == EVENTS.ADDON_LOADED and ... == "Broker_ilvl" then
		if not Broker_ilvlDB[playerRealm] then Broker_ilvlDB[playerRealm] = {} end
		LibStub("tekKonfig-AboutPanel").new(nil, "Broker_ilvl")
		self:UnregisterEvent("ADDON_LOADED")
		self.ADDON_LOADED = nil
		UpdateText()
		--if IsLoggedIn() then UpdateText() else self:RegisterEvent("PLAYER_LOGIN") end
		
	else
		UpdateText()
		--if (event == EVENTS.QUEST_DETAIL) or (event == EVENTS.PLAYER_EQUIPMENT_CHANGED) or (event == EVENTS.PLAYER_LOGIN) then UpdateText() end
	end
end
	
function BI_OnLoad(self)
	BI_LocalMessage("BI_OnLoad")
	if not Broker_ilvlDB then
		Broker_ilvlDB = {}
	end
	
	for _,v in pairs(EVENTS) do
		self:RegisterEvent(strupper(v));
	end
	
end

function BI_LocalMessage(message)
	--DEFAULT_CHAT_FRAME:AddMessage(tostring("BI - " .. message));
end